_G.AllTheGadgets = _G.AllTheGadgets or {}
local ATG = _G.AllTheGadgets
ATG._path = AllTheGadgetsCore and AllTheGadgetsCore:GetPath() or ModPath
ATG._data_path = SavePath .. "ActivateMultipleGadgets.txt"
ATG._menu_path = ATG._path .. "menu/options.json"

--create entries for all settings
ATG.default_settings = {
	atg_enabled = true,
	atg_overload = false --turns ALL gadgets on at once
}

--duplicate settings so that old saves after an update will still get any new settings entries
ATG.settings = ATG.settings or {}
for k,v in pairs(ATG.default_settings) do 
	if ATG.settings[k] == nil then
		ATG.settings[k] = v
	end
end

function ATG:IsEnabled()
	return self.settings.atg_enabled
end

function ATG:IsOverloadModeEnabled()
	return self.settings.atg_overload
end

function ATG:Load()
	local file = io.open(self._data_path, "r")
	if (file) then
		for k, v in pairs(json.decode(file:read("*all"))) do
			self.settings[k] = v
		end
	else
		self:Save()
	end
end

function ATG:Save()
	local file = io.open(self._data_path,"w+")
	if file then
		file:write(json.encode(self.settings))
		file:close()
	end
end

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_atg", function( loc )
	if not BeardLib then
		loc:load_localization_file( ATG._path .. "localization/english.json")
	end
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_atg", function(menu_manager)

	MenuCallbackHandler.callback_atg_enabled = function(self,item)
		ATG.settings.atg_enabled = item:value() == "on"
		ATG:Save()
	end
	
	MenuCallbackHandler.callback_atg_overload = function(self,item)
		ATG.settings.atg_overload = item:value() == "on"
		ATG:Save()
	end
	
	MenuCallbackHandler.atg_toggle_sight_gadget = function(self)
		if Utils:IsInHeist() and Utils:IsInCustody() == false and Utils:IsInGameState() then--doesn't cover all cases, but it at least shouldn't crash
			local state = managers.player:local_player():movement():current_state()
			local wpn = state._equipped_unit:base()	
			if wpn then
				local is_on = wpn:is_second_sight_on()
				wpn:toggle_second_sight()
				state:_stance_entered() --refreshes stance
			end
		end
	end
	
	MenuCallbackHandler.callback_atg_close = function(this)
--		ATG:Save() --redundant
	end
	ATG:Load()
	MenuHelper:LoadFromJsonFile(ATG._menu_path, ATG, ATG.settings)	
	
end)